import java.io.*;
import java.util.*;

public class Substitution {
	Hashtable encryptTable ;
	Hashtable decryptTable ;
	Hashtable occurences ;

	public Substitution (){
		encryptTable = new Hashtable();
		decryptTable = new Hashtable();
		occurences = new Hashtable();
	}

	protected void printTable(Hashtable h) {
		Iterator it = h.keySet().iterator();
		while (it.hasNext()) {
    			Object key =   it.next();
    			Object value = h.get(key);
			
			System.out.println("clef " + key.toString() + " valeur " + value.toString());    
		}
	}

	public void printDecryptTable() {
		System.out.println("Table de dechiffrement ");
		printTable(decryptTable);
	}

	public void printEncryptTable() {
		System.out.println("Table de chiffrement ");
		printTable(encryptTable);
	}

	public void compteOccurencesLettres(String message) {
		String s = message.toUpperCase();
		for (int i=0; i<s.length();i++) {
			char c = s.charAt(i);
				
			if (Character.isLetter(c)) {
				String key = String.valueOf(c);
				if (occurences.containsKey(key)) {
					Integer value = (Integer) occurences.get(key);
					value++;
					occurences.put(key, new Integer(value));
				}
				else
					occurences.put(key, new Integer(1));
			}
		}
		printTable(occurences);
	}

	public void addToTable(char c, char e) {
		encryptTable.put(String.valueOf(c),String.valueOf(e));
		decryptTable.put(String.valueOf(e),String.valueOf(c));
	}

	public void addToEncryptTable(char c, char e) {
		encryptTable.put(String.valueOf(c),String.valueOf(e));
	}

	public void addToDecryptTable(char c, char e) {
		decryptTable.put(String.valueOf(c),String.valueOf(e));
	}

	// Chiffrement : chaque lettre est remplacee par son
	// code dans la table d'encryption.
	// Si la lettre ne figure pas dans la table,
	// on laisse la lettre telle quelle
	public String encrypt (String message) {
		String encryptedMessage =  new String();

		for (int i=0; i<message.length();i++) {
			char c = message.charAt(i);
			
			String key = String.valueOf(c);
			if (Character.isLetter(c) && encryptTable.containsKey(key)) {
					String value = (String) encryptTable.get(key);
					encryptedMessage = encryptedMessage.concat(value);
			
			}
			else 
					encryptedMessage = encryptedMessage.concat(key);
		}

		return encryptedMessage;
	}

	// Dechiffrement : chaque lettre est remplacee par son
	// code dans la table de dechiffrement
	// Si la lettre ne figure pas dans la table,
	// on la remplace par un '_'
	public String decrypt (String message) {
		String decryptedMessage =  new String();

		for (int i=0; i<message.length();i++) {
			char c = message.charAt(i);
			String key = String.valueOf(c);
			// Si ce n'est pas une lettre, on laisse tel quel
			if (! Character.isLetter(c) )
				decryptedMessage = decryptedMessage.concat(key);
			else {
				if (decryptTable.containsKey(key)) {
					String value = (String) decryptTable.get(key);
					decryptedMessage = decryptedMessage.concat(value);
				}
				else 
					decryptedMessage = decryptedMessage.concat(String.valueOf('_'));
			}
		}

		return decryptedMessage;
	}

	// Ceci prepare une table de chiffrement ou de déchiffrement
	// a la cesar (avec comme clef la valeur du décalage a faire)
	public void translation (int n) {
		encryptTable.clear();
		decryptTable.clear();
		// On remplit les deux hashtable avec les lettres
		// de A a Z en prenant en compte le decalage...
		
		char e;		// le code associe a c

		// parcourt des lettres
		for (char c = 'A';c<='Z';c++) {
			// decalage
			e=c;
			for (int j=0;j<n;j++){
				e++;
				if (e>'Z') e='A';
			}
			addToTable(c,e);
			
		}

	}

	public void clearDecryptTable() {
		decryptTable.clear();
	}

	public void clearEncryptTable() {
		encryptTable.clear();
	}


}

